unit uMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls,JvCreateProcess, SysTray, Menus, ImgList,
  JvComponent,JvSimpleXML, strutils, clipbrd;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    RichEdit1: TRichEdit;
    RunBtn: TButton;
    TerminateBtn: TButton;
    JvCreateProcess1: TJvCreateProcess;
    SysTray1: TSysTray;
    PopupMenu1: TPopupMenu;
    Mostra1: TMenuItem;
    Nascondi1: TMenuItem;
    Esci1: TMenuItem;
    ImageList1: TImageList;
    Timer1: TTimer;
    Eseguinewcs1: TMenuItem;
    Fermanewcs1: TMenuItem;
    About1: TMenuItem;
    editor: TRichEdit;
    newcsxml1: TMenuItem;
    Visualizza1: TMenuItem;
    Modifica1: TMenuItem;
    Salva1: TMenuItem;
    Chiudi1: TMenuItem;
    Lingue1: TMenuItem;
    Label1: TLabel;
    procedure RunBtnClick(Sender: TObject);
    procedure TerminateBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JvCreateProcess1Terminate(Sender: TObject; ExitCode: Cardinal);
    procedure JvCreateProcess1RawRead(Sender: TObject; const S: String);
    procedure Mostra1Click(Sender: TObject);
    procedure Eseguinewcs1Click(Sender: TObject);
    procedure Fermanewcs1Click(Sender: TObject);
    procedure Nascondi1Click(Sender: TObject);
    procedure Esci1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function elenco_file(directory:string):tstringlist;
    procedure aggiornastatomenu;
    procedure aggiornalinguamenu(lingua:string);
    procedure selezionelingua(sender: tobject);
    procedure PopupMenu1Change(Sender: TObject; Source: TMenuItem;
      Rebuild: Boolean);
    procedure About1Click(Sender: TObject);
    procedure Visualizzaxml1Click(Sender: TObject);
    procedure Visualizza1Click(Sender: TObject);
    procedure Modifica1Click(Sender: TObject);
    procedure Salva1Click(Sender: TObject);
    procedure Chiudi1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure editorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    procedure UpdateButtons;
  end;

var
  MainForm: TMainForm;
  visibile:boolean;
  cfggui,listoflng:tstringlist;
  workpath,lingua,mshow,mhide,mrun,mstop,mshowxml,medit,msave,mclose,mexit,mabout,mlanguage:string;

implementation

uses
  uabout,JvJCLUtils;
{$R *.DFM}

resourcestring
  sProcessStarted = 'Process "%s" started...';
  sProcessTerminated = 'Process "%s" terminated, ExitCode: %.8x';

procedure TMainForm.selezionelingua(sender:tobject);
var lingua:string;
begin
   with sender as TMenuItem do
   begin
     lingua:=caption;
     lingua:=ReplaceStr(lingua,'&','');
     aggiornalinguamenu(lingua);
   end;
end;

function TMainForm.elenco_file(directory:string):tstringlist;
var
  sr: TSearchRec;
  FileAttrs: Integer;
  elenco:tstringlist;
begin
    elenco:=tstringlist.create;
    FileAttrs := faDirectory;
    if sysutils.FindFirst(directory+'*.lng', FileAttrs, sr) = 0 then
    begin
      repeat
        if ((sr.name <> '.')and(sr.name <> '..')) then
          elenco.Add(sr.Name);
      until FindNext(sr) <> 0;
      sysutils.FindClose(sr);
    end;
    Result:=elenco;
end;

procedure inizializzavocimenu;
begin
  mshow := 'Show';
  mhide := 'Hide';
  mrun := 'Run newcs';
  mstop := 'Stop newcs';
  mshowxml := 'Show';
  medit := 'Edit';
  msave := 'Save and close';
  mclose := 'Close';
  mexit := 'Exit';
  mlanguage := 'Language';
  mabout := 'About';
end;

procedure TMainForm.aggiornalinguamenu(lingua:string);
var
 lngloaded:tstringlist;
 i:byte;
begin
  lngloaded:=tstringlist.create;
  lngloaded.LoadFromFile(workpath+lingua+'.lng');
  if length(trim(lngloaded.Text))>0 then
    begin
      cfggui:=tstringlist.create;
      cfggui.Add(lingua);
      cfggui.SaveToFile(workpath+'newcsgui.cfg');
      cfggui.Free;
      for i := 0 to lngloaded.Count-1 do
        begin
          if lngloaded.Strings[i][1]<>';' then
            begin
              if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='show' then
                 mshow:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='hide' then
                     mhide:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='run' then
                     mrun:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='stop' then
                     mstop:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='showxml' then
                     mshowxml:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='edit' then
                     medit:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='save' then
                     msave:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='close' then
                     mclose:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='exit' then
                     mexit:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='language' then
                     mlanguage:=ExtractWord(2,lngloaded.Strings[i],[':'])
              else if LowerCase(ExtractWord(1,lngloaded.Strings[i],[':']))='about' then
                     mabout:=ExtractWord(2,lngloaded.Strings[i],[':']);
            end;
        end;
    end
    else showmessage(lingua+'.lng IS NOT a valid language file!');
    lngloaded.Free;
end;

procedure TMainForm.aggiornastatomenu;
begin   
  if (JvCreateProcess1.State = psRunning) or (JvCreateProcess1.State = pswaiting) then
    begin
      Eseguinewcs1.Enabled:=false;
      Fermanewcs1.Enabled:=true;
      newcsxml1.Enabled:=false;
    end
  else
    begin
      Eseguinewcs1.Enabled:=true;
      Fermanewcs1.Enabled:=false;
      newcsxml1.Enabled:=true;
    end;

  if MainForm.Visible then
    begin
      mostra1.Enabled:=false;
      nascondi1.Enabled:=true;
    end
  else
    begin
      mostra1.Enabled:=true;
      nascondi1.Enabled:=false;
    end;
end;

procedure TMainForm.RunBtnClick(Sender: TObject);
begin
  JvCreateProcess1.CommandLine:=workpath+'newcs.exe -c '+workpath+'newcs.xml';
  JvCreateProcess1.Run;
  ImageList1.GetIcon(1,SysTray1.Icon);
  UpdateButtons;
end;

procedure TMainForm.TerminateBtnClick(Sender: TObject);
begin
  JvCreateProcess1.Terminate;
  ImageList1.GetIcon(0,SysTray1.Icon);
end;

procedure TMainForm.UpdateButtons;
begin
  RunBtn.Enabled := JvCreateProcess1.State = psReady;
  TerminateBtn.Enabled := JvCreateProcess1.State <> psReady;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i:byte;
newmenuitem:tmenuitem;
begin
  workpath:=IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
  cfggui:=tstringlist.create;
  if not FileExists(workpath+'newcs.exe') then
    begin
      showmessage('Missing newcs.exe! Application terminated!');
      Application.Terminate;
    end;
  if not FileExists(workpath+'newcs.xml') then
    begin
      showmessage('Missing newcs.xml! Application terminated!');
      Application.Terminate;
    end;
  if FileExists(workpath+'newcsgui.cfg') then
    cfggui.LoadFromFile(workpath+'newcsgui.cfg')
  else
    begin
      showmessage('Missing newcsgui.cfg file! Application terminated!');
      Application.Terminate;
    end;
  listoflng:=tstringlist.create;
  listoflng.AddStrings(elenco_file(workpath));
  for i:=0 to listoflng.Count-1 do
    begin
      NewMenuItem := TMenuItem.Create(Self);
      NewMenuItem.AutoHotkeys := maManual;
      if pos(cfggui.strings[0]+'.lng',listoflng.Strings[i])>0 then
        begin
          lingua:=cfggui.strings[0];
          NewMenuItem.Caption := lingua;
        end
      else NewMenuItem.Caption := ChangeFileExt(ExtractFileName(listoflng.Strings[i]),'');
      NewMenuItem.OnClick := selezionelingua;
      lingue1.Insert(i,newmenuitem);
    end;
  lingue1.Items[lingue1.Count-1].visible:=false;
  listoflng.Free;
  cfggui.Free;
  timer1.Enabled:=true;
  visibile:=false;
  UpdateButtons;
  SysTray1.Visible:=true;
  RunBtnClick(self);
  aggiornastatomenu;
  inizializzavocimenu;
  aggiornalinguamenu(lingua);
end;

procedure TMainForm.JvCreateProcess1Terminate(Sender: TObject; ExitCode: Cardinal);
begin
  UpdateButtons;
end;

procedure TMainForm.JvCreateProcess1RawRead(
  Sender: TObject; const S: String);
var i:integer;
t:string;
begin
  t:='';
  for i:=1 to length(s) do
    if (not(ord(s[i])=13)) and (not(ord(s[i])=10)) then
      t:=t+s[i];

  RichEdit1.Lines.Add(s);
end;

procedure TMainForm.Mostra1Click(Sender: TObject);
begin
  MainForm.show;
end;

procedure TMainForm.Eseguinewcs1Click(Sender: TObject);
begin
  RunBtnClick(self);
end;

procedure TMainForm.Fermanewcs1Click(Sender: TObject);
begin
  TerminateBtnClick(self);
end;

procedure TMainForm.Nascondi1Click(Sender: TObject);
begin
  MainForm.hide;
end;

procedure TMainForm.Esci1Click(Sender: TObject);
begin
  if (JvCreateProcess1.State = psRunning) or (JvCreateProcess1.State = pswaiting) then
      TerminateBtnClick(self);
  Application.Terminate;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  timer1.Enabled:=false;
  MainForm.hide;
end;

procedure TMainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=canone;
end;

procedure TMainForm.PopupMenu1Change(Sender: TObject;
  Source: TMenuItem; Rebuild: Boolean);
begin
  aggiornastatomenu;
end;

procedure TMainForm.About1Click(Sender: TObject);
var visibile:boolean;
begin
  visibile:=false;
  if MainForm.Visible then
    begin
      visibile:=true;
      mainform.Hide;
    end;
  aboutbox:=taboutbox.Create(self);
  AboutBox.Showmodal;
  FreeAndNil(aboutbox);
  if visibile then MainForm.Show;
end;

procedure TMainForm.Visualizzaxml1Click(Sender: TObject);
var i:integer;
riga,tagi,tagf,voce:string;
commento,tag,comando:boolean;
filexml:tstringlist;
begin
   if newcsxml1.Caption='ne&wcs.xml' then
     begin
       editor.Clear;
       newcsxml1.Caption:='~ne&wcs.xml';
       filexml:=tstringlist.create;
       filexml.LoadFromFile(workpath+'newcs.xml');
       filexml.Text:=
       XMLDecode(filexml.Text);

       commento:=false;
       tag:=false;
       comando:=false;
       editor.DefAttributes.Color := clBlack;
       for i:=0 to filexml.count-1 do
         begin
            riga:=trim(filexml.strings[i]);
            if length(riga)>0 then
              begin
                if (riga[1]='<') and (riga[2]='!') and (riga[3]='-') and (riga[4]='-') then
                  begin
                    commento:=true;
                    editor.SelAttributes.Color:=clGray;
                    editor.SelAttributes.Style:=[fsItalic];
                    editor.lines.Add(filexml.strings[i]);
                  end
                else if commento then
                  begin
                    if (riga[length(riga)-2]='-') and (riga[length(riga)-1]='-') and (riga[length(riga)]='>') then
                      commento:=false;
                    editor.SelAttributes.Color:=clGray;
                    editor.SelAttributes.Style:=[fsItalic];
                    editor.lines.Add(filexml.strings[i]);
                  end
                else
                  begin
                    tagi:=copy(riga,0,pos('>',riga));
                    riga:=copy(riga,pos('>',riga)+1,length(riga));
                    tagf:=copy(riga,pos('<',riga),length(riga));
                    voce:=copy(riga,0,pos('<',riga)-1);
                    riga:=copy(filexml.strings[i],0,pos('<',filexml.strings[i])-1);
                    editor.Lines.Add('');
                    editor.seltext:=riga;
                    editor.SelAttributes.Color:=clBlue;
                    editor.SelAttributes.Style:=[];
                    editor.SelText:=tagi;
                    editor.SelAttributes.Color:=clBlack;
                    editor.SelAttributes.Style:=[fsBold];
                    editor.SelText:=voce;
                    editor.SelAttributes.Color:=clBlue;
                    editor.SelAttributes.Style:=[];
                    editor.seltext:=tagf;
                  end;
              end
              else editor.lines.Add('');
          end;
       filexml.free;
       editor.Visible:=true;
     end
   else
     begin
       newcsxml1.Caption:='ne&wcs.xml';
       editor.Visible:=false;
     end;
end;

procedure TMainForm.Visualizza1Click(Sender: TObject);
begin
  if visualizza1.Caption[1]<>'~' then
    begin
      editor.ReadOnly:=true;
      visualizza1.Caption:='~'+mshowxml;
      visualizza1.Enabled:=false;
      modifica1.Enabled:=false;
      salva1.Enabled:=false;
      chiudi1.Enabled:=true;
      Eseguinewcs1.Enabled:=false;
      Visualizzaxml1Click(self);
    end;
end;

procedure TMainForm.Modifica1Click(Sender: TObject);
begin
  if Modifica1.Caption[1]<>'~' then
    begin
      editor.ReadOnly:=false;
      modifica1.Caption:='~'+medit;
      modifica1.Enabled:=false;
      visualizza1.enabled:=false;
      salva1.Enabled:=true;
      chiudi1.Enabled:=true;
      Eseguinewcs1.Enabled:=false;
      Visualizzaxml1Click(self);
    end;
end;

procedure TMainForm.Salva1Click(Sender: TObject);
begin
  editor.Lines.SaveToFile(workpath+'newcs.xml');
  editor.Visible:=false;
  modifica1.Caption:=medit;
  newcsxml1.Caption:='newcs.xml';
  editor.Visible:=false;
  visualizza1.Enabled:=true;
  modifica1.Enabled:=true;
  Salva1.Enabled:=false;
  chiudi1.Enabled:=false;
  Eseguinewcs1.Enabled:=true;
end;

procedure TMainForm.Chiudi1Click(Sender: TObject);
begin
  if visualizza1.Caption[1]='~' then
      visualizza1.Caption:=mshowxml
  else modifica1.Caption:=medit;
  newcsxml1.Caption:='newcs.xml';
  editor.Visible:=false;
  visualizza1.Enabled:=true;
  modifica1.Enabled:=true;
  Salva1.Enabled:=false;
  chiudi1.Enabled:=false;
  Eseguinewcs1.Enabled:=true;
end;



procedure TMainForm.PopupMenu1Popup(Sender: TObject);
begin
  mostra1.Caption:=mshow;
  nascondi1.Caption:=mhide;
  Eseguinewcs1.Caption:=mrun;
  Fermanewcs1.Caption:=mstop;
  Visualizza1.Caption:=mshowxml;
  modifica1.Caption:=medit;
  salva1.Caption:=msave;
  chiudi1.Caption:=mclose;
  lingue1.Caption:=mlanguage;
  esci1.Caption:=mexit;
  about1.Caption:=mabout;
end;

procedure TMainForm.editorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button = mbRight then
    if length(trim(editor.SelText))>0 then
       Clipboard.AsText := editor.SelText;
end;

end.

